import upygame as upg
import framebuf
import urandom as random
import umachine
from micropython import const
import gc

import tile
import level
import player
import camera
import inputs

upg.display.init()
upg.display.set_palette_16bit([
	0,6474,31018,1066,24009,43654,25289,50712,59594,64771,63333,21819,33715,62388,65141,65437,
]);
screen_sf = upg.display.set_mode() # full screen

cam = camera.Camera(55,44)
inputs = inputs.Inputs()


lvl = level.Level(12,12)
xStart,yStart =  lvl.loadLevel(0)
p1 = player.Player(xStart,yStart,8,8)


us = umachine.time_us()
while True:

    #if(umachine.time_us()-us)>20:
    us = umachine.time_us()
    
    inputs.update()
    
    cam.update(p1.xs,p1.ys)
    
    lvl.updateAndDraw(screen_sf,cam)
    
    p1.update(inputs,lvl)
    p1.draw(screen_sf,cam)
    
    upg.display.flip()
    
    if (lvl.outOfMargin(p1)):
        umachine.wait(500)
        xStart,yStart = lvl.loadNext(0)
        p1 = player.Player(xStart,yStart,8,8)
    
    if(inputs.BTrigger):
        xStart,yStart = lvl.loadNext(1)
        p1 = player.Player(xStart,yStart,8,8)
    
    if(inputs.CTrigger):
        gc.collect()
        print ("free:",gc.mem_free())
        print('---')
    

    
    
    