# tile.py

import upygame as upg
import moveData


class Tile:
    def __init__(self,solid,pixels,x,y,w,h,move = None):
        self.solid = solid
        self.x = x
        self.y = y
        self.w = w
        self.h = h
        self.move = move
        self.pixels = pixels
        self.surface = upg.surface.Surface(w, h, pixels[0])
        this_rect = self.surface.get_rect()
        self.frame = 0
        
    def collide(self,other_rect):
        this_rect = self.surface.get_rect()
        this_rect.x = self.x
        this_rect.y = self.y
        if (this_rect.colliderect(other_rect)):
            return self
        
    def update(self):
        #time
        self.frame += 1
        if self.frame > 1000:
            self.frame = 0
        #move
        if self.move:
            self.move.update()
            this_rect = self.surface.get_rect()
            self.x = self.move.getX()
            self.y = self.move.getY()
        
        #animation
        findex = self.frame // 2 % len(self.pixels)
        this_rect = self.surface.get_rect()
        self.surface = upg.surface.Surface(self.w, self.h, self.pixels[findex])
    
    
    def draw(self,screen,cam):
        this_rect = self.surface.get_rect()
        xs = cam.getX() + self.x
        ys = cam.getY() + self.y
        if(xs>110 or (xs+self.w)<0 or ys>88 or (ys+self.h)<0):
            return False
        else:
            screen.blit(self.surface,xs,ys)
            return True
        
        
        